% prelucrarea imaginilor folosind Matlab
% extragerea trasaturilor, in scopul recunoasterii

close all
clear all

% =========================================================================
% se transforma imaginea RGB obiecte2.jpg n imagine grayscale

nume='obiecte3.jpg';
disp(nume)
I=imread(nume);
I1=rgb2gray(I);                             % imagine monocroma cu functia rgb2gray
dim=size(I1);
prag = 120;                                 % pragul de segmentare
for i=1:dim(1)
    for j=1:dim(2)
        if I1(i,j)<prag                         % segmentarea cu prag
            I1(i,j)=0;
        else
            I1(i,j)=255;
        end
    end
end
figure
imshow(I1);
title('imaginea segmentata si filtrata')
pause
% figure
% imhist(I1)
% title('histograma')
I1=255-I1;                      % se inverseaza luminanta, conform cu conventia functiei bwlabel
                                % fondul = 0 (negru), obiect = 255 (alb)

% =========================================================================
% etichetarea
[L,num]=bwlabel(I1,8);                 % L = matricea etichetelor
aria=zeros(1,num+1);                  % sirul ariilor obiectelor
sumx=zeros(1,num+1);                    % suma absciselor
sumy=zeros(1,num+1);                    % suma ordonatelor
maxx=zeros(1,num+1);                    % abscisa maxima
maxy=zeros(1,num+1);                    % ordonata maxima
minx=ones(1,num+1)*dim(2);                    % abscisa minima
miny=ones(1,num+1)*dim(1);                    % ordonata minima

for i=1:dim(1)
    for j=1:dim(2)
        et=L(i,j)+1;
        aria(et)=aria(et)+1;
        sumx(et)=sumx(et)+j;
        sumy(et)=sumy(et)+i;
        if j>maxx(et)
            maxx(et)=j;
        end
        if j<minx(et)
            minx(et)=j;
        end
        if i>maxy(et)
            maxy(et)=i;
        end
        if i<miny(et)
            miny(et)=i;
        end
    end
end
disp('imaginea prelucrata, numar de obiecte si ariile (prima arie reprezinta fondul, nu un obiect)')
disp(num)
disp(aria)
pause

% centx=sumx./aria;
% centy=sumy./aria;
% disp('centrele de greutate, x')
% disp(round(centx))
% disp('centrele de greutate, y')
% disp(round(centy))

% =========================================================================
% imagine cu contururile obiectelor
cont=I1;                               % copie in care voi pastra numai contururi
for i=2:dim(1)-1
    for j=2:dim(2)-1
        if I1(i,j)==255 & (I1(i-1,j)==0||I1(i,j+1)==0||I1(i+1,j)==0||I1(i,j-1)==0)
            cont(i,j)=255;                      % pixelii contururilor sint obiecte
        else
            cont(i,j)=0;                % fondul + interiorul obiectelor
        end
    end
end
figure
imshow(cont);                           % numar prea mare de pixeli, rezolutia ecranului este insuficienta 
title('contururile obiectelor')
pause

% =========================================================================
% etichetarea contururilor
[et1,nr2]=bwlabel(cont);         % imagine cu etichetele contururilor
disp('numarul de contururi')
disp(nr2)
et3=et1;                        % copie de folosit ulterior, la perimetre
%determinarea numarului de pixeli pentru fiecare contur
arie1=zeros(1,nr2+1);  % numarul de obiecte plus fondul
initi=zeros(3,nr2+1);   % coordonatele pixelului initial din fiecare contur
                        % plus indicator daca a fost inregistrat pixel init

for i=1:dim(1)
    for j=1:dim(2)
        et2=et1(i,j)+1;
        if initi(3,et2)==0   % indicator daca a fost inregistrat pixel init
            initi(1,et2)=i;  % linia pixelului initial
            initi(2,et2)=j;  % coloana pixelului initial
            initi(3,et2)=1;  % a fost inregistrat pixel init
        end
        arie1(et2)=arie1(et2)+1;    % numarul de pixeli din contur
    end
end
% disp('numarul de pixeli de pe fiecare contur (prima arie reprezinta fondul, nu un contur)')
% disp(arie1)

% =========================================================================
% codul lant pentru fiecare contur
for E=1:nr2                             % E = eticheta conturului analizat
    cod=zeros(1,arie1(E+1));            % vectorul in care se va gasi codul lant
    i=initi(1,E+1);                     % coordonatele pixelului initial
    j=initi(2,E+1);
%unui pixel parcurs i se asociaza valoarea 200 pentru a evita parcurgerea lui
%de mai multe ori
    for n=1:arie1(E+1)
        if et1(i,j+1)==E
            et1(i,j+1)=200;
            cod(n)=0;                   % codul exprima directia in care se afla urmatorul pixel de pe contur
            j=j+1;
            continue;
        end
        if et1(i+1,j+1)==E
            et1(i+1,j+1)=200;
            cod(n)=7;
            i=i+1;
            j=j+1;
            continue;
        end
        if et1(i+1,j)==E
            et1(i+1,j)=200;
            cod(n)=6;
    	    i=i+1;
            continue;
        end
        if et1(i+1,j-1)==E
            et1(i+1,j-1)=200;
            cod(n)=5;
    	    i=i+1;
            j=j-1;
            continue;
        end
        if et1(i,j-1)==E
            et1(i,j-1)=200;
            cod(n)=4;
    	    j=j-1;
            continue;
        end
        if et1(i-1,j-1)==E
            et1(i-1,j-1)=200;
            cod(n)=3;
    	    i=i-1;
            j=j-1;
            continue;
        end
        if et1(i-1,j)==E
            et1(i-1,j)=200;
            cod(n)=2;
    	    i=i-1;
            continue;
        end   	
        if et1(i-1,j+1)==E
            et1(i-1,j+1)=200;
            cod(n)=1;
    	    i=i-1;
            j=j+1;
            continue;
        end
    end
%     c=int2str(cod(1));                  % variabila alfanumerica care memoreaza codul lant
%     for i=1:arie1(E+1)
%         c=[c int2str(cod(i))];
%     end
    nr_pare=0;                          % numar de cifre pare in codul lant
    nr_impare=0;                        % numar de cifre impare in codul lant
    for i=1:arie1(E+1)
        if mod(cod(i),2)==0
            nr_pare=nr_pare+1;
        else
            nr_impare=nr_impare+1;
        end
    end
    perim(E+1)=nr_pare+nr_impare*sqrt(2);    % calculul perimetrului
end

% =========================================================================
% afisare contururi
for E=1:nr2                     % explorez etichetele, incepind cu 1
    I2=zeros(dim(1),dim(2));
    for i=1:dim(1)
        for j=1:dim(2)
            if et3(i,j)==E  I2(i,j)=255;   end
        end
    end
    imshow(I2)                  % imagine cu conturul cu eticheta E
    tit=['eticheta ' int2str(E) '    aria ' int2str(aria(E+1)) '    perimetrul ' int2str(perim(E+1))];
    title(tit)           % eticheta asociata
    pause
end

% =========================================================================
% calcul compactness
for E=1:nr2                     % explorez etichetele, incepind cu 1
    compact(E+1)=perim(E+1)*perim(E+1)/aria(E+1);
end
disp('compact')
disp(compact)
pause

% =========================================================================
% afisare vectori, in coordonatele: compactness, aria

figure
plot(aria(2:nr2+1), compact(2:nr2+1),'x');
title('compact vs aria')
xlabel('aria')
pause
vec(1:2,1:nr2)=[compact(2:nr2+1); aria(2:nr2+1)];
vec(3,1:nr2)=[1 2 2 1 1 3 3 2 2 2 1 3 3 3 2 2 1 3 1 3 3];
pause

figure
axis([0 8000 12 26])
for i=1:nr2
    text(vec(2,i),vec(1,i),int2str(vec(3,i)))
end
title('compact vs aria')
xlabel('aria')

disp('gata')
disp(' ')
