% afisarea functiei spectrale pentru perturbatie de 50Hz peste semnal audio, fisier .wav
% se observa linia spectrala a perturbatiei, peste liniile spectrale ale
% semnalului original

% Fs este frecventa de esantionare
% n este numarul de esantioane inregistrate
% y este sirul esantioanelor inregistrate

clear all
close all
[y,Fs]=wavread('pia60');                % citeste fisier cu inregistrarea audio
disp(Fs)                                % afiseaza frecventa de esantionare
[n,m]=size(y);                          % dimensiunea inregistrarii (vector coloana)
timp=(1:n)/Fs*1000;                     % sirul valorilor timpului, n esantioane
plot(timp,y(:,1))                       % diagrama de timp a semnalului inregistrat 
title('pia60.wav')
xlabel('timp (ms)')
pause

figure
plot(timp(10001:11500),y(10001:11500))  % diagrama de timp, doar 1500 esantioane
title('pia60.wav, 1500 esantioane')
xlabel('timp (ms)')
pause

yt=abs(fft(y));                         % calculeaza modulul transformatei Fourier
figure
sir1=(1:3000);                          % sir de 3000 esantioane
frecv=sir1*Fs/n;                        % sirul valorilor frecventei (primele 3000 esantioane)
plot(frecv,yt(sir1))                    % afiseaza primele 3000 esantioane ale modulului FFT
title('modulul functiei spectrale, semnal original')
xlabel('frecventa (Hz)')
pause

z=0.05*sin(2*pi*100*(1:n)/Fs);          % sirul valorilor zgomotului, armonic, aceeasi frecv. esantionare
z=z';                                   % vector coloana
%wavwrite(z,Fs,'z100Hz')                % scrie un fisier cu zgomotul
ym=y+z;                                 % ym este semnalul perturbat (semnal initial + zgomot)
%wavwrite(ym,Fs,'pia60z')               % scrie un fisier cu semnalul perturbat

figure
plot(timp(10001:11500),z(10001:11500))  % afiseaza zgomotul (1500 esantioane)
title('zgomot 100Hz, 1500 esantioane')
xlabel('timp (ms)')
pause
figure
plot(timp(10001:11500),ym(10001:11500)) % afiseaza semnalul perturbat (1500 esantioane)
title('pia60z.wav, 1500 esantioane')
xlabel('timp (ms)')
yt=abs(fft(ym));                        % calculeaza modulul transformatei Fourier, semnal perturbat
pause
figure
frecv=(1:3000);
plot(frecv*Fs/n,yt(frecv))              % modulul FFT semnal perturbat, primele 3000 esantioane
title('modulul functiei spectrale, semnal perturbat')
xlabel('frecventa (Hz)')
disp('gata')
